



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【C++对象模型】第二章  构造函数语意学</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【C++对象模型】第二章  构造函数语意学</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-21 00:31:30 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>1、Default Constructor</h2>
<p>　　当编译器需要的时候，default constructor会被合成出来，只执行编译器所需要的任务（将members适当初始化）。</p>
<h3>1.1 &nbsp;带有 Default Constructor 的Member Class Object</h3>
<p>　　编译器的出来是：如果一个class A 内含一个或者一个以上 member class objects ，那么class A 的每一个 constructor 必须调用每一个member classes 的default constructor 。编译器会扩张已存在的constructors,在其中安插一些代码，使得 user code在被执行之前，先调用（调用顺序一member objects在class 的声明次序一致）必要的 default constructors。（例如：一个类中包含了两个成员，一个成员是一个对象，而另一个成员是built-in的变量，那么编译器会调用这个member对象的默认构造器，built-in变量就会置之不理。）</p>
<p>　　注意：这样的编译器默认合成构造器，是隐式的，如果类本身存在构造器，那么编译器会在程序需要的(可以理解为user code )代码之前，安插必要的default constructor。</p>
<p>　　举个例子，假设我们有以下三个classes：</p>
<div>
<pre class="prettyprint linenums">class Dopey {public: Dopey();...};<br />
class Sneezy {public: Sneezy(int); Sneezy();...};<br />
class Bashful {public: Bashful();...};</pre>
</div>
<p>　　以及一个class Snow_White：</p>
<div>
<pre class="prettyprint linenums">class Snow_White<br />
{<br />
public:<br />
    Dopey dopey;<br />
    Sneezy sneezy;<br />
    Bashful bashful;<br />
private:<br />
    int mumble;<br />
};</pre>
</div>
<p>　　如果Snow_White没有定义default constructor，就会有一个nontrivial constructor被合成出来，依序调用Dopey、Sneezy、Bashful的default constructors。然而如果Snow_White定义了下面这样的default constructor：</p>
<div>
<pre class="prettyprint linenums">//程序员所写的default constructor<br />
Snow_White::Snow_White(): sneezy()<br />
{<br />
    mumble = ;<br />
}</pre>
</div>
<p>　　它将会被扩张为：</p>
<div>
<pre class="prettyprint linenums">//编译器扩张后的default constructor<br />
Snow_White::Snow_White():sneezy()<br />
{<br />
    //插入member class object<br />
    //调用其constructor<br />
    dopey.Dopey::Dopey();<br />
    sneezy.Sneezy::Sneezy();<br />
    bashful.Bashful::Bashful();

    //expilict user code<br />
    mumble = ;<br />
}</pre>
</div>
<h3>1.2&nbsp;带有 Default Constructor 的 Base class</h3>
<p>　　如果没有定义构造函数，编译器会产生一个nontrivial constructor，先调用相应的base class's constructor，如果用户自己定义了constructor，那么编译器将会安插调用所必要的default constructors的程序代码到用户自己定义的constructor中。（通俗地讲：用户已经定义了构造函数，但是没有定义默认构造函数，那么编译器会把默认的东西加在进去，但不会重新写一个default constructor出来）。</p>
<h3>1.3 带有一个 Virtual Function 的Class</h3>
<p>　　下面两种情况同样需要合成default constructor：</p>
<ul><li>class 声明（或继承）一个 virtual function。</li>
<li>class派生自一个继承串链，其中一个或者更多的 virtual base class。</li></ul>
<p>　　扩展（constructor）操作会在编译期间发生：</p>
<ul><li>一个virtual function table 会被编译器产生出来，内放class 的virtual functions 的地址。</li>
<li>在每一个 class object 中，一个额外的pointer member（vptr)会被编译器合成出来，内含相关的class vtbl的地址。</li></ul>
<h3>1.4 带有一个 Virtual Base Class 的class</h3>
<p>　　Virtual base class的实现法在不同编译器之间有很大差异，然而，每一个实现的共同点在于必须使 virtual base class 在其每一个 derived class object中的位置，能够在执行期准备妥当。对于class所定义的每一个constructor 编译器都会安插那些&ldquo;允许每一个virtual base class 的执行期存取操作&rdquo;的码。</p>
<h3>1.5 总结</h3>
<p>　　以上四种情况，会导致&ldquo;编译器必须为未声明constructor 的class 合成一个default constructor &rdquo;，这只是编译器（而非程序）的需要。它之所以能够完成任务，是借着&ldquo;调用member object 或base class的default constructor &rdquo;或是&ldquo;为每一个object初始化其 virtual function 机制或virtual base class 机制&rdquo;完成。至于没有存在这四种情况而又没有生命constructor的class 实际上是不会被合成出来的。</p>
<p>　　在合成的default constructor 中，只有base class subobjects(子对象）和member class objects会被初始化。所有其他的nonstatic data member ，如整数，整数指针，整数数组等是不会被初始化的，这些初始化操作对程序是必须的，但对编译器则并非需要的。</p>
<p>　　C++新手一般有两个误解：</p>
<ul><li>任何class 如果没有定义default constructor ，就会被合成出来一个。</li>
<li>编译器合成出来的default constructor 会明确设定 class 内每一个data member的默认值。</li></ul>
<h2>2、Copy Constructor</h2>
<h3>2.1 拷贝情况</h3>
<p>　　有三种情况，会以一个object的内容作为另一class object的初值。</p>
<p>　　1.最明显的当然是对一个object做明确的初始化操作。</p>
<p>　　2.当object被当做参数交给某个函数</p>
<p>　　3.当函数返回一个class object。</p>
<p>　　这三种情况需要有 copy constructor。</p>
<h3>2.2&nbsp;Default Memberwise Initialization</h3>
<p>　　如果class 没有提供一个 explicit copy constructor(显示拷贝构造函数)时，当class object以&ldquo;相同的另一个object作为初值是，其内部是以所谓的default memberwise initialization方式完成的。也就是把每一个内建的或派生的 data member（例如一个数组或指针）的值，从某个object拷贝一份到另一个object上，但不拷贝其具体内容。例如只拷贝指针地址，不拷贝一份新的指针指向的对象，这也就是浅拷贝，不过它并不会拷贝其中member class object，而是以递归的方式实行memberwise initialization。</p>
<p>　　这种递归的memberwise initialization是如何实现的呢？</p>
<p>　　答案就是Bitwise Copy Semantics和default copy constructor。如果class展现了Bitwise Copy Semantics，则使用bitwise copy（bitwise copy semantics编译器生成的伪代码是memcpy函数），否则编译器会生成default copy constructor。</p>
<p>　　那什么情况下class不展现Bitwise Copy Semantics呢？</p>
<p>　　有四种情况：</p>
<p>　　1.当class内含有一个member class object，而这个member class 内有一个默认的copy 构造函数[不论是class设计者明确声明，或者被编译器合成]</p>
<p>　　2.当class 继承自 一个base class，而base class 有copy构造函数[不论是class设计者明确声明，或者被编译器合成]</p>
<p>　　3.当一个类声明了一个或多个virtual 函数</p>
<p>　　4.当class派生自一个继承串链，其中一个或者多个virtual base class</p>
<p>　　下面我们来理解这四种情况为什么不能使用bitwise copy，以及编译器生成的copy constructor都干了些什么。</p>
<p>　　在前2种情况下，编译器必须将member或者base class的&ldquo; copy constructor的调用操作&rdquo;安插到被合成的copy constructor中。</p>
<p>　　第3种情况下，因为class 包含virtual function， 编译时需要做扩张操作：</p>
<p>　　1.增加virtual function table，内含有一个有作用的virtual function的地址；</p>
<p>　　2.创建一个指向virtual function table的指针，安插在class object内。</p>
<p>　　所以，编译器对于每一个新产生的class object的vptr都必须被正确地赋值，否则将跑去执行其他对象的function了，其后果是很严重的。因此，编译器导入一个vptr到class之中时，该class 就不在展现bitwise semantics，必须合成copy Constructor并将vptr适当地初始化。</p>
<h3>2.3&nbsp;处理Virtual Base Class Subobject</h3>
<p>　　virtual base class的存在需要特别处理。一个class object 如果以另一个 virtual base class subobject那么也会使&ldquo;bitwise copy semantics&rdquo;失效。</p>
<p>　　每一个编译器对于虚拟继承的支持承诺，都是表示必须让&ldquo;derived class object 中的virtual base class subobject 位置&rdquo;在执行期就准备妥当，维护&ldquo;位置的完整性&rdquo;是编译器的责任。Bitwise copy semantics 可能会破坏这个位置，所以编译器必须自己合成出copy constructor。</p>
<p>　　这也就是说，拷贝构造函数和默认构造器一样，需要的时候会进行构建，而并非程序员不写编译器就帮着构建。</p>
<h3>2.4&nbsp;初始化列表</h3>
<p>　　下面四种情况必须使用初始化列表来初始化class 的成员：</p>
<p>　　1.当初始化一个reference member时；</p>
<p>　　2.当初始化一个const member时；</p>
<p>　　3.当调用一个base class 的 constructor ，而它拥有一组参数（其实就是自定义的构造函数）时；</p>
<p>　　4.当调用一个 member class 的 constructor，而它拥有一组参数时。</p>
<p>　　这里总的需要留意两点：</p>
<p>　　第一个：member object的初始化，最好放到初始化列表里面。若放置于构造器中，则会产生临时的object0，初始化之，在做赋值运算给object，然后object0自行销毁，期间耗时耗力。若置于初始化列表，则编译器会在构造函数中，user code之前，调用object的构造函数，予以初始化。</p>
<p>　　第二个：初始化列表的初始化次序。初始化次序和member在类中的声明次序一致。相互关联的member，需要十分留意初始化列表中，其中依赖的次序。解决的办法：把其中一部分使用初始化列表初始化，而另一部分放置到构造函数中使用user code予以表达，这样即便次序存在依赖，也会只&ldquo;先执行合成的，再执行user的code&rdquo;。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9p2p78x.html">CanvasWebgl项目介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv2wgj9.html">C&num;创建安全的字典&lpar;Dictionary&rpar;存储结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwp4lz8.html">hadoop中map和reduce的数量设置问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z11y1v9.html">20150203一些移动端H5小bug解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdeeydz9.html">css中的zoom</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdejgo79.html">仿酒仙网的一款jQuery侧栏弹出导航栏特效</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e15xkz9.html">Powershell导入订阅号（以Azure中国版为例）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde4d609.html">HDU 1495  非常可乐  BFS 搜索</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdvx7e8.html">字符&lpar;汉子&rpar;转换为ASCII</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rggvgr8.html">（大数据工程师学习路径）第一步 Linux 基础入门----目录结构及文件基本操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kjko49.html">BZOJ 2324&colon; &lbrack;ZJOI2011&rsqb;营救皮卡丘&lpar;带上下限的最小费用最大流&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zolng1q.html">Mobiscroll的介绍【一款兼容PC和移动设备的滑动插件】</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzgokl8.html">性能测试监控：Jmeter &plus;InfluxDB &plus;collectd &plus;Grafana</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojoxolq.html">在C&num;中&OpenCurlyDoubleQuote;？&rdquo;有三种用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz6nee8.html">xpath获取下一页&comma;兄弟结点的妙用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz51eg8.html">linux系统自动备份打包部署脚本</a>
		</li>
						<li><a href="https://www.batexi.com/a/9506ov08.html">Python-Django基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv0kry8.html">NODE&lowbar;ENV不是内部或外部命令&comma;也不是可运行的程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkyj118.html">在发送信息时应用PendingIntent&period;FLAG&lowbar;UPDATE&lowbar;CURRENT</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwllzrk9.html">Patterns for Asynchronous MVVM Applications&colon; Commands</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q2xxw0x9.html">SGU 438 The Glorious Karlutka River &equals;&rpar;（最大流）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9g33molq.html">定点数&lpar;fixed-point number&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pmmd3z9.html">软件工程第六周psp</a>
			</li>
						<li><a href="https://www.batexi.com/a/93jjylz8.html">20145214 《Java程序设计》第5周学习总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy221mm9.html">poj 3009 &lpar;深搜求最短路&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/90ddrr48.html">python学习摘要（4）--列表简单处理</a>
			</li>
						<li><a href="https://www.batexi.com/a/qd55wmx9.html">lintcode-39-恢复旋转排序数组</a>
			</li>
						<li><a href="https://www.batexi.com/a/q444my5q.html">Directory类的使用、Alt&plus;Shift&plus;F10可以查看其命名空间</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jeep0g8.html">get computer system mac info in javascript</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2xx0yw9.html">Spring AOP 源码解析</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
